##Exercise 2
#####################
##1
##First convert .xls file to text file
##growth data set weight gain after six weeks in animals based on four supplements
animal_growth<-read.table("L:/home/mazerolm/Documents/Stats consulting/R Intro Workshop/English/animal_growth.txt", header=TRUE)
animal_growth<-read.table(file.choose( ))

##a
##compute a boxplot on the growth variable for each group
##What do you notice about the variability in each group?
boxplot(animal_growth$gain~animal_growth$supplement)


##b
##compute mean for each supplement
sapply(split(animal_growth$gain,animal_growth$supplement),sd)  #compute sd of each group
sapply(split(animal_growth$gain,animal_growth$supplement),mean)  #compute mean of each group
##or
tapply(X=animal_growth$gain, INDEX=animal_growth$supplement, FUN=mean)
tapply(X=animal_growth$gain, INDEX=animal_growth$supplement, FUN=sd)
##example of creating a function 'on the fly' in tapply( )
tapply(X=animal_growth$gain, INDEX=animal_growth$supplement, FUN=function(x)sd(x)/sqrt(length(x)))


##c - d
##simple function to compute confidence interval (two-tailed)
Conf_int<-function(x,conf.level) {            #x denotes the variable to use; conf.level denotes the confidence level, 0.95, 0.90, 0.99
mean_x<-mean(x) ##compute mean of x

SE_x<-sd(x)/sqrt(length(x)) ##compute SE of x

df<-length(x)-1     ##degrees of freedom for t-distribution

lower_tail<-(1-conf.level)/2

upper_tail<-lower_tail+conf.level

t<-qt(p=upper_tail,df=df)

Lower_lim<-mean_x-t*SE_x    ##compute lower confidence limit

Upper_lim<-mean_x+t*SE_x    ##compute upper confidence limit

method = "Computation of confidence interval"
list("Confidence level" = conf.level, "Lower limit" = Lower_lim, "Upper limit" = Upper_lim,"Mean" = mean_x, "SE" = SE_x)
}

##same function, but with more elements that can be extracted
Conf_int2<-function(x,conf.level=0.95) {            #x denotes the variable to use; conf.level denotes the confidence level, 0.95, 0.90, 0.99
data.name<-deparse(substitute(x))
mean_x<-mean(x) #compute mean of x
SE_x<-sd(x)/sqrt(length(x))  #compute SE of x
df<-length(x)-1     #degrees of freedom for t-distribution
lower_tail<-(1-conf.level)/2
upper_tail<-lower_tail+conf.level
t<-qt(p=upper_tail,df=df)
Lower_lim<-mean_x-t*SE_x    #compute lower confidence limit
Upper_lim<-mean_x+t*SE_x    #compute upper confidence limit
method = "Computation of confidence interval"
names(data.name) <- "Variable"
names(mean_x) <- "Mean of variable"
names(SE_x) <- "SE"
names(conf.level) <- "Confidence level"
names(Lower_lim) <- "Lower confidence limit"
names(Upper_lim) <- "Upper confidence limit"
list(method=method, data.name = data.name, mean_x = mean_x, SE_x = SE_x, conf.level = conf.level, Lower_lim=Lower_lim, Upper_lim=Upper_lim)
}


##compute 95% CI on the mean of the diet for the control group
##What do you notice about the width of the CI?
agri<-animal_growth[animal_growth$supplement=="agrimore",]
mean_agri<-mean(agri$gain)
SE_agri<-sd(agri$gain)/sqrt(length(agri$gain))
agri_int<-Conf_int(agri$gain,0.95) #95% CI


super<-animal_growth[animal_growth$supplement=="supergain",]
mean_super<-mean(super$gain)
SE_super<-sd(super$gain)/length(super$gain)
super_int<-Conf_int(super$gain,0.95)

control<-animal_growth[animal_growth$supplement=="control",]
mean_control<-mean(control$gain)
SE_control<-sd(control$gain)/length(control$gain)
control_int2<-Conf_int(control$gain,0.95)

supersupp<-animal_growth[animal_growth$supplement=="supersupp",]
mean_supersupp<-mean(supersupp$gain)
SE_supersupp<-sd(supersupp$gain)/length(supersupp$gain)
supersupp_int<-Conf_int(supersupp$gain,0.95)

##alternative strategy is to use the function created for CI computation with tapply( )
##compute the 95% CI on the mean of the diet for each of the treatment groups
##IC  95% avec tapply( ) en appliquant la fonction sur chaque combinaison de donnes
tapply(X=animal_growth$gain, INDEX=animal_growth$supplement, FUN=function(i) Conf_int(i, conf.level=0.95))
##extract lower limit only
tapply(X=animal_growth$gain, INDEX=animal_growth$supplement, FUN=function(i) Conf_int(i, conf.level=0.95)[2])
##extract upper limit only
tapply(X=animal_growth$gain, INDEX=animal_growth$supplement, FUN=function(i) Conf_int(i, conf.level=0.95)[3])



#####################
##2
new.var <- c(2, 3, 24, 12, 5, 9, 17, 6, 10, 20, 21, 5)

##a
set.seed(seed = 12)
##this allows repeatability for random number generators, otherwise, results will change every time
##you run the function (takes the seed from the computer clock to plug in the algorithm)
sampled.var <- sample(x = new.var, replace = TRUE)

##b
sort(sampled.var, decreasing = FALSE)
median(sampled.var)

##c
sort.med <- function(variable, decreasing.ord = FALSE) {
  sort.x <- sort(variable, decreasing = decreasing.ord)
  median.x <- median(sort.x)
  list("Sorted.variable" = sort.x, "Median.variable" = median.x)
}

sort.med(sampled.var)



#####################
##3
##mean growth
growth.mean <- c(12, 25)
##SE of mean growth
growth.se <- c(9.9, 14.1)
##add labels - optional
names(growth.mean) <- c("non-drained", "drained")
names(growth.se) <- c("non-drained", "drained")


##create empty plot with type = "n"
plot(0 ~ 0, ylab = "Mean growth (mm/year)", xlab = "Drainage",
ylim = c(0, 40), xlim = c(0, 3), xaxt = "n", type = "n")

##add x axis
axis(side = 1, at = c(1, 2), labels = c("non-drained", "drained"))

##create a vector of position on the x axis for drainage type
drain <- c(1, 2)

##add points
points(growth.mean ~ drain, col = "turquoise")

##compute lower and upper limits
low.lim <- growth.mean - growth.se
upp.lim <- growth.mean + growth.se

##error bars
arrows(x0 = drain, y0 = low.lim, x1 = drain, y1 = upp.lim,
col = "darkred", length=.05, angle=90, code=3)



##to save graph in jpeg format
jpeg(file = "L:/home/mazerolm/Documents/graph1.jpeg", width = 500, height = 500, quality = 100, bg = "transparent")
##create empty plot with type = "n"
plot(0 ~ 0, ylab = "Mean growth (mm/year)", xlab = "Drainage", ylim = c(0, 40), xlim = c(0, 3), xaxt = "n", type = "n")

##add x axis
axis(side = 1, at = c(1, 2), labels = c("non-drained", "drained"))

##create a vector of position on the x axis for drainage type
drain <- c(1, 2)

##add points
points(growth.mean ~ drain, col = "turquoise")

##compute lower and upper limits
low.lim <- growth.mean - growth.se
upp.lim <- growth.mean + growth.se

##error bars
arrows(x0 = drain, y0 = low.lim, x1 = drain, y1 = upp.lim, col = "darkred", length=.05, angle=90, code=3)

##close graphic device
dev.off()



##to save graph in pdf format
pdf(file = "L:/home/mazerolm/Documents/graph1.pdf")
##create empty plot with type = "n"
plot(0 ~ 0, ylab = "Mean growth (mm/year)", xlab = "Drainage", ylim = c(0, 40), xlim = c(0, 3), xaxt = "n", type = "n")

##add x axis
axis(side = 1, at = c(1, 2), labels = c("non-drained", "drained"))

##create a vector of position on the x axis for drainage type
drain <- c(1, 2)

##add points
points(growth.mean ~ drain, col = "turquoise")

##compute lower and upper limits
low.lim <- growth.mean - growth.se
upp.lim <- growth.mean + growth.se

##error bars
arrows(x0 = drain, y0 = low.lim, x1 = drain, y1 = upp.lim, col = "darkred", length=.05, angle=90, code=3)

##close graphic device
dev.off()
